.\"	$NetBSD: setregid.2,v 1.22 2004/05/13 10:20:58 wiz Exp $
.\"
.\" Copyright (c) 1998, 2000, 2001 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Charles M. Hannum.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.\"
.\" Copyright (c) 1983, 1991 The Regents of the University of California.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     from: @(#)setregid.2	6.4 (Berkeley) 3/10/91
.\"
.Dd January 5, 2001
.Dt SETREGID 2
.Os
.Sh NAME
.Nm setregid
.Nd set real and effective group ID's
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In unistd.h
.Ft int
.Fn setregid "gid_t rgid" "gid_t egid"
.Sh DESCRIPTION
.Bf -symbolic
This interface is made obsolete by the saved ID functionality in
.Xr setgid 2
and
.Xr setegid 2 .
.Ef
.Pp
The real and effective group ID's of the
current process are set according to the arguments.
If the real group ID is changed, the saved group ID is changed to the
new value of the effective group ID.
.Pp
If
.Fa rgid
or
.Fa egid
is \-1, the current gid is filled in by the system.
Unprivileged users may change the real group
ID to the effective group ID, and may change the effective group ID to the
real group ID or the saved group ID; only the super-user may
make other changes.
.Pp
The
.Fn setregid
function has been used to swap the real and effective group
IDs in set-group-ID programs to temporarily relinquish the set-group-ID
value.
This purpose is now better served by the use of the
.Fn setegid
function (see
.Xr setgid 2 ) .
.Pp
When setting the real and effective group IDs to the same value, this
function is equivalent to the
.Fn setgid
function.
When setting only the effective group ID, this function is equivalent to
the
.Fn setegid
function.
.Sh RETURN VALUES
Upon successful completion, a value of 0 is returned.
Otherwise, a value of \-1 is returned and
.Va errno
is set to indicate the error.
.Sh ERRORS
.Bl -tag -width Er
.It Bq Er EPERM
The current process is not the super-user and a change
other than changing the effective group-id to the real group-id
was specified.
.El
.Sh SEE ALSO
.Xr getgid 2 ,
.Xr setegid 2 ,
.Xr setgid 2 ,
.Xr setuid 2
.Sh HISTORY
The
.Fn setregid
function call appeared in
.Bx 4.2 .
An incompatible version was implemented in
.Bx 4.4 .
It was reimplemented in
.Nx 1.2
in a way compatible with
.Bx 4.3 ,
SunOS and Linux, but should not be used in new code.
